VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CDepartment"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"CSubDepartment"
Attribute VB_Ext_KEY = "Member0" ,"CSubDepartment"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'local variable to hold collection
Private m_nChildren As Collection

Private m_iDeptID As Integer
Private m_iNextDeptID As Integer
Private m_INextPFID As Integer

Private m_iParentId As Integer
Private m_sDeptName As String
Private m_sImageFileName As String


Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    'this property allows you to enumerate
    'this collection with the For...Each syntax
    Set NewEnum = m_nChildren.[_NewEnum]
End Property


Private Sub Class_Initialize()
    'creates the collection when this class is created
    Set m_nChildren = New Collection
End Sub


Private Sub Class_Terminate()

    Debug.Print "GoodBye: " & m_iDeptID
    'destroys collection when this class is terminated
    Set m_nChildren = Nothing
    
End Sub

Property Get Count() As Integer
    Count = m_nChildren.Count
End Property

Property Get SKUCount() As Integer
    
    'SKUCount is only called on top level stores.  Get the count of the
    ' product family of the children (for now)
    
    Dim iCount As Integer
    iCount = 0
    
    Dim oDepartment As CDepartment
    For Each oDepartment In m_nChildren
        iCount = iCount + oDepartment.Count
    Next
    Set oDepartment = Nothing
    
    SKUCount = iCount
    
End Property

Property Get NextDeptID() As Integer
    NextDeptID = m_iNextDeptID
    
End Property

Private Sub PrivateAddSubDepartments(ByVal frm As Form)

        Dim oDepartment As CDepartment
        Set oDepartment = New CDepartment
        
        oDepartment.dept_id = m_iNextDeptID
        frm.txtSubDept = m_iNextDeptID
                
        m_iNextDeptID = m_iNextDeptID + 1
        oDepartment.parent_id = m_iDeptID
                
        m_nChildren.Add oDepartment
        oDepartment.AddProducts frm
                
        Set oDepartment = Nothing
        Set frm = Nothing
        
End Sub

Private Sub PrivateAddProducts(ByVal iPFID As Integer, ByVal frm As Form)

    Dim oProductFamily As New CProductFamily

    m_nChildren.Add oProductFamily
    
    Dim sDept As String
    If m_iDeptID < 10 Then
        sDept = "0" & CStr(m_iDeptID)
    Else
        sDept = CStr(m_iDeptID)
    End If
    
    Dim sPFID As String
    If iPFID < 10 Then
        sPFID = "00" & CStr(iPFID)
    ElseIf iPFID < 100 Then
        sPFID = "0" & CStr(iPFID)
    Else
        sPFID = CStr(iPFID)
    End If
    
    With oProductFamily
    
        .pf_id = sPRODUCT_FAMILY_PREFIX & sDept & "-" & sPFID
        .pf_name = .pf_id & " " & sPRODUCT_FAMILY_NAME
        .pf_description = .pf_id & " " & sPRODUCT_FAMILY_DESCRIPTION
        .dept_id = m_iDeptID
        .size_type = RandomSizeType()
        .date_intro = RandomDateIntro()
        Dim l As Long
        l = RandomInteger(iMIN_PRICE, iMAX_PRICE)
        l = l * 100
        .list_price = l
        .sale_price = RandomSalePrice(l)
        .sale_start = .date_intro + (RandomInteger(0, 8) * 30)
        .sale_end = .sale_start + (RandomInteger(1, 8) * 30)
        .image_file_name = sPRODUCT_FAMILY_IMAGE_FILE_NAME
        
        ' now that you've added the product family, add it's variants
        .AddProductVariants frm
                
    End With
    
    
    Set oProductFamily = Nothing
    Set frm = Nothing
    
End Sub

Public Sub AddProducts(ByVal frm As Form)

    Dim iMaxSKUs As Integer
    iMaxSKUs = CInt(frm.txtSKUs)

    ' add 1 to 100 product families
    Dim i As Integer
    Dim iMaxProducts As Integer
    iMaxProducts = RandomInteger(iMIN_PRODUCT_FAMILY, iMAX_PRODUCT_FAMILY)
    
    For i = iMIN_PRODUCT_FAMILY To iMaxProducts
        PrivateAddProducts i, frm
        frm.txtProductFamily = iMaxProducts
        
        If MaxVariants(0, iMaxSKUs) Then
            ' bail out at maximum
            Set frm = Nothing
            Exit Sub
        End If
        
    Next i
    
    
    
        
    Set frm = Nothing
End Sub

Public Sub AddSubDepartments(ByVal frm As Form)
    Dim iMaxSKUs As Integer
    iMaxSKUs = CInt(frm.txtSKUs)
    
    Dim i As Integer
    Dim iMaxSubDepartments As Integer
    iMaxSubDepartments = RandomInteger(iMIN_SUB_DEPARTMENTS, iMAX_SUB_DEPARTMENTS)
    
    For i = iMIN_SUB_DEPARTMENTS To iMaxSubDepartments
    
        PrivateAddSubDepartments frm
        
        If MaxVariants(0, iMaxSKUs) Then
            ' bail out at maximum
            Set frm = Nothing
            Exit Sub
        End If
                
    Next
    
    Set frm = Nothing
       
End Sub

Property Let dept_id(ByVal iDeptID As Integer)
    
    m_iDeptID = iDeptID
    m_iNextDeptID = iDeptID + 1
    
    
End Property

Property Get dept_id() As Integer
    dept_id = m_iDeptID
End Property

Property Let parent_id(ByVal iParentID As Integer)
    
    m_iParentId = iParentID
    
    m_sDeptName = sDEPARTMENT_PREFIX & CStr(m_iDeptID)
    m_sImageFileName = sDEPARTMENT_IMAGE_FILE_NAME
        
End Property

Property Get parent_id() As Integer
    parent_id = m_iParentId
End Property

Property Let dept_name(ByVal sDeptName As String)
    m_sDeptName = sDeptName
End Property

Property Get dept_name() As String
    dept_name = m_sDeptName
End Property

Property Let image_file_name(ByVal sImageFileName As String)
    m_sImageFileName = sImageFileName
End Property

Property Get image_file_name() As String
    image_file_name = m_sImageFileName
    
End Property

Property Get featured_pf_id() As String
    
    If m_iParentId = 0 Then
        Dim oDepartment As CDepartment
        Set oDepartment = m_nChildren(1)
        featured_pf_id = oDepartment.featured_pf_id
    Else
        featured_pf_id = m_nChildren(1).pf_id
    End If
    
End Property


Public Sub Enumerate(ByVal bJulian As Boolean)
        
    Dim oDepartment As CDepartment
    For Each oDepartment In m_nChildren
        EnumerateDepartment oDepartment
        oDepartment.EnumeratePF bJulian
    Next

End Sub

Public Sub EnumeratePF(ByVal bJulian As Boolean)

    Dim oProductFamily As CProductFamily
    For Each oProductFamily In m_nChildren
        EnumerateProductFamily oProductFamily, bJulian
        oProductFamily.EnumerateVariants
    Next

End Sub
